# Limb3 Architecture
## Overview

* [MVC](./architecture/limb_mvc.md) — Limb and MVC pattern.

## Controller

* [Controller](./architecture/controller.md) — The key concepts of Limb Controller
* [Intercepting Filters Chain](./architecture/filters.md)
* [lmbService](./architecture/lmb_service.md) — What is lmbService, what is the purpose of Services and where do I define Services.
* [RequestDispatching](./architecture/request_dispatching.md) — How do we dispatch request and determine requested lmbService and Action.
* [lmbCommand](./architecture/lmb_command.md)
* [Validation](./architecture/validation.md)

## Model

* [Model](./architecture/model.md)
* [DataContainer](./architecture/data_container.md)
* [DBAL](./architecture/dbal.md)
* [ORM](./architecture/orm.md) — lmbObject/Relational Mapping
  * [lmbDataMapper](./architecture/lmb_data_mapper.md)
  * [lmbUnitOfWork](./architecture/lmb_unit_of_work.md)
  * [lmbProxy](./architecture/lmb_proxy.md)
* [DAO](./architecture/daos.md) — Data Access lmbObject
* [DataFlow](./architecture/data_flow.md)

## View

* [View](./architecture/view.md)
* [lmbSimpleView](./architecture/lmb_simple_view.md)
* [lmbFormView](./architecture/lmb_form_view.md)

## Other aspects of Limb architecture

* [lmbFileSchema](./architecture/lmb_file_schema.md)
* [lmbToolkit](./architecture/lmb_toolkit.md)
