# Пакет MACRO (шаблонная система {{macro}})
Первоначальная идея MACRO (или **{{macro}}**, что равнозначно) возникла из нашей практики использования шаблонной системы WACT-а. Первоначально WACT строился исходя из следующих принципов:

* XML-подобный синтаксис.
* Наличие контекстов, из которых выводятся данные.

Эти два обстоятельства значительно усложняют использование WACT-а в случаях, когда вы имеете дело со сложной логикой отображения. Более трети документации на WACT посвящено контекстам. Кроме этого контексты и XML-подобный синтаксис значительно усложняют внутренную архитектуру WACT-а, которую становится все сложнее поддерживать.

В результате дискусий родился MACRO как более простая, но не менее мощная альтернатива WACT-у:

* [первоначальная идея MACRO](http://forum.limb-project.com/viewtopic.php?t=1918)
* [промежуточные соглашения перед началом разработки MACRO](http://forum.limb-project.com/viewtopic.php?t=2030)
* [ход разработки MACRO](http://forum.limb-project.com/viewtopic.php?t=2281)

Для тех, кто ранее работал с WACT-ом, проблем с переходом на MACRO быть не должно.

Отличительной особенностью MACRO от WACT-а является и то, что MACRO не является полностью независимым пакетом. Пакет MACRO имеет зависимости от CORE и FS пакетов, что позволяет использовать проверенные временем решения и не «изобретать колесо».

Если вы только начинаете разбираться с MACRO, мы рекомендуем читать страницы секции «Информация по использованию MACRO» подряд, сверху вниз.

## Справочная информация по MACRO

* [Словарь тегов](./macro/tags.md)
* [Словарь фильтров](./macro/filters.md)

## Информация по использованию MACRO

* **Базовые знания**
  * [Плюсы и минусы MACRO шаблонизатора](./macro/pros_and_cons.md)
  * [Отличия MACRO от WACT-а](./macro/diffs_from_wact.md)
  * [Введение в шаблонную систему MACRO. Основные элементы шаблонов](./macro/intro.md)
  * [Компиляция и выполнение шаблона. Пример рендеринга MACRO-шаблона](./macro/important_details.md)
  * [Как MACRO-шаблон получает данные для вывода?](./macro/data_sources.md)
  * **Основные элементы шаблона**
      * [Выражения. Вывод значений переменных в шаблоне](./macro/expressions.md)
      * [Фильтры. Модификация значений при выводе](./macro/filters_intro.md)
      * [Использование php-кода в шаблонах](./macro/php_code_in_templates.md)
* **Базовые средства шаблонизации MACRO**
  * [Вывод списков](./macro/list_tags.md)
  * [Постраничный вывод списков](./macro/pagination.md)
  * [Теги форм и элементов форм](./macro/form_tags.md)
  * [Композиция шаблонов (включение, обворачивание и переиспользование шаблонов)](./macro/template_composition.md)
* **Механизм шаблонизатора MACRO**
  * [Словари элементов MACRO-шаблона (Какие элементы шаблона распознает MACRO? Словари тегов и фильтров)](./macro/dictionaries.md)
  * [Механизм поиска шаблонов(Как MACRO ищет шаблоны)](./macro/template_file_name_resolving.md)
  * [Сообщения об ошибках и отладка шаблонов](./macro/errors_and_debug.md)

## Информация для расширения MACRO

* [Как работает компилятор MACRO-шаблонов](./macro/compiler.md)
* [Создание своих тегов](./macro/how_to_create_new_tag.md)
* [Создание своих фильтров](./macro/how_to_create_new_filter.md)
* Расширение механизма поиска шаблонов. Поддержка скинов, языкозависимых шаблонов и т.д
